local whisperEventName = 'CHAT_MSG_WHISPER'
local partyEventName = 'CHAT_MSG_PARTY'
local tradeSkillShowEvent = 'TRADE_SKILL_SHOW'
local tradeSkillCloseEvent = 'TRADE_SKILL_CLOSE'
local tradeSkillShowEvent = 'TRADE_SKILL_SHOW'
local craftCloseEvent = 'CRAFT_CLOSE'
local craftOpenEvent = 'CRAFT_SHOW'
local loadedTradeSkill = false
local professionName

local function MyAddonCommands(msg, editbox)
    -- pattern matching that skips leading whitespace and whitespace between cmd and args
    -- any whitespace at end of args is retained
    local _, _, cmd, args = string.find(msg, "%s?(%w+)%s?(.*)")
    if cmd == "clear" then
        TSWClear()
    end
    if cmd == "enchant" or cmd == "enchanting" or cmd == "enc" or  cmd == "e" then
        name, realm = UnitName("target")
        msg = "To list all enchants i can do type !enchant, or simply !bracer, !neck, etc.."
        Whisper(msg, name)
    end
    if cmd == "alchemy" or cmd == "alc" or cmd == "a" then
        name, realm = UnitName("target")
        msg = "To list all alchemy recipes i can do type !alchemy, or simply !potion, !flask, !elixir, etc.."
        Whisper(msg, name)
    end
    if cmd == "tailoring" or cmd == "tailor" or cmd == "tai" or cmd == "t" then
        name, realm = UnitName("target")
        msg = "To list all tailoring recipes i can do type !tailoring, or simply !bag, !cloth, etc.."
        Whisper(msg, name)
    end
    if cmd == "help" then
        name, realm = UnitName("target")
        msg = "You can list my professions by whispering me !help"
        Whisper(msg, name)
    end
end

SLASH_TRADESKILLWHISPER1 = '/tsw'
SlashCmdList["TRADESKILLWHISPER"] = MyAddonCommands  

local function OnEvent(self, event, msg, from, ...)
    if event == tradeSkillShowEvent then
        professionName = GetTradeSkillLine()
    end 
    if event == tradeSkillCloseEvent then
        if professionName == "Tailoring" then
            GenerateTailoringArray(professionName)
        else
            GenerateArray(professionName)
        end
    end 
    if event == craftOpenEvent then
        professionName = GetCraftDisplaySkillLine()
    end
    if event == craftCloseEvent then
        GenerateEnchantingArray(professionName)
    end
    if event == whisperEventName then
        arg = Arguments(msg)
        if ValidPrefix(arg[1]) then
            if not IsThisSpam(msg, from) then
                arr = PwDb(arg[1])
                SendResponce(arg,arr,from)
            end
        end
    end
end

local f = CreateFrame("Frame")
f:RegisterEvent(whisperEventName)
f:RegisterEvent(tradeSkillShowEvent)
f:RegisterEvent(tradeSkillCloseEvent)
f:RegisterEvent(craftCloseEvent)
f:RegisterEvent(craftOpenEvent)
f:SetScript("OnEvent", OnEvent)