function GetSpellId(spellName)
        return select(7, (GetSpellInfo(spellName)))
end

function Whisper(msg, to)
	SendChatMessage(msg, "WHISPER", nil, to)
end

function Color(str, color)
    local c = '';

    if color == 'red' then
        c = '|cFFff0000';
    elseif color == 'gray' then
        c = '|cFFa6a6a6';
    elseif color == 'purple' then
        c = '|cFFB900FF';
    elseif color == 'blue' then
        c = '|cB900FFFF';
    elseif color == 'lightBlue' then
        c = '|cB900FFFF';
    elseif color == 'reputationBlue' then
        c = '|cFF8080ff';
    elseif color == 'yellow' then
        c = '|cFFffff00';
    elseif color == 'orange' then
        c = '|cFFFF6F22';
    elseif color == 'green' then
        c = '|cFF00ff00';
    elseif color == "white" then
        c = '|cFFffffff';
    elseif color == "gold" then
        c = "|cFFffd100" -- this is the default game font
    end

    return c .. str .. "|r"
end



function TSWClear()
    Pwc("Profile for "..TSWPlayerName.." has been cleared.")
    _G.TSWRecipeList[TSWPlayerName] = {}
end

function Prefixes()
    prefixes = {}
    k = 1
    prefixes[k] = {}
    prefixes[k]["name"] = TSWPrefix.."help"
    k = k + 1
    if TSWRecipeList[TSWPlayerName] == nil then
        return prefixes
    end
    for i=1, #TSWRecipeList[TSWPlayerName] do
        local lower = string.lower(TSWRecipeList[TSWPlayerName][i]["name"])
        prefixes[k] = {}
        prefixes[k]["name"] = TSWPrefix..lower
        prefixes[k]["sub"] = {}
        
        for c=1, #TSWRecipeList[TSWPlayerName][i]["categorys"] do
            prefixes[k]["sub"][c] = {}
            lower = string.lower(TSWRecipeList[TSWPlayerName][i]["categorys"][c]["name"])
            prefixes[k]["sub"][c]["name"] = TSWPrefix..lower
        end
        k = k + 1
    end
    --print("Prefixes: "..#prefixes)
    return prefixes
end

function ValidPrefix(arg)   
    prefixes = Prefixes()
    for i=1, #prefixes do
        if arg == prefixes[i]["name"] then
            return true
        end
        if prefixes[i]["sub"] then
            for c=1, #prefixes[i]["sub"] do
                if arg == prefixes[i]["sub"][c]["name"] then
                    return true
                end
            end
        end 
    end
    return false
end

function IsThisSpam(msg, from)        
    local theTime = floor(GetTime())
    local count = 0
    local lastRequest = 0
    local cooldown = 60
    local secleft = 0
    
    if PwRequests[from] then
        count = PwRequests[from]['msgCount']
        lastRequest = PwRequests[from]['lastRequest']
        count = count + 1 
    else
        PwRequests[from] = {}
        lastRequest = theTime
        count = 1;
    end
    
    if((theTime - lastRequest) > cooldown)then
        count = 1;
    end
    
    if(count > 10) then
        secleft = cooldown + lastRequest - theTime
        Whisper("Can you please stop spaming? "..secleft.." sec left on ignore.", from)    
        return true
    end
    lastRequest = theTime
    PwRequests[from]['msgCount'] = count
    PwRequests[from]['lastRequest'] = lastRequest

    return false
end

function Arguments(msg)
	k = 1
	arg = {}

    for w in msg:gmatch("%S+") do   
        arg[k] = w
        k = k + 1
    end

    return arg
end

function GetDbMarketPrice(itemID)
	local TSM_API = _G.TSM_API
    local dbmarket = TSM_API.GetCustomPriceValue("dbmarket", "i:"..itemID)
    return dbmarket
end

function GetMinBuyoutPrice(itemID)
    if AsGetPrice then
        return AsGetPrice(itemID)
    end
    if _G.TSM_API then
	    local TSM_API = _G.TSM_API
        local dbminbuyout = TSM_API.GetCustomPriceValue("dbminbuyout", "i:"..itemID)
        return dbminbuyout
    end
    Pwc("You need Auction House Scan to use this addon")
    return
end

function GetVendorPrice(itemID)
    local TSM_API = _G.TSM_API
    local vendor = TSM_API.GetCustomPriceValue("vendorbuy", "i:"..itemID)
    return vendor
end

function GetPrice(itemID)
    if AsGetVendorPrice(itemID) then
        return AsGetVendorPrice(itemID)      
    elseif GetVendorPrice(itemID) then
        return GetVendorPrice(itemID)
    end
    return GetMinBuyoutPrice(itemID)
end
    
function FormatPrice(dbmarket)
    if dbmarket == nil then
        return "Not in db"
    end
    local g = math.floor(math.floor(dbmarket/100)/100)
    local s = math.floor(math.floor(dbmarket - (g * 100 * 100)) /100)
    local c = dbmarket - (g * 100 * 100) - (s * 100)
    
    if(g == 0) then gt = "" else gt = g.."g " end
    if(s == 0) then st = "" else st = s.."s " end
    if(c == 0) then ct = "" else ct = c.."c " end
    local price = gt..st..ct
    return price
end

function GetItemLink(itemID)
    return select(2, GetItemInfo(itemID))
end

function TSWDebug(msg)
    if TSWDebugEnabled then
        Pwc(msg)
    end 
end

function GenerateEnchantingArray(professionName)
    local name, type, headerCount, itemCount, professionId, foundCloth, professionNameShort;
    local professionId
    if professionName ~= "Enchanting" then
        return
    end
    if TSWRecipeList[TSWPlayerName] == nil then
        Pwc("New profile for "..TSWPlayerName)
        TSWRecipeList[TSWPlayerName] = {}
    end
    for i=1, 6 do
        if TSWRecipeList[TSWPlayerName][i] == nil then
            professionId = i
            Pwc(tostring(professionName).." added")
            break
        else
            if TSWRecipeList[TSWPlayerName][i]["name"] == professionName then
                professionId = i
                break
            end
        end
    end

    TSWRecipeList[TSWPlayerName][professionId] = {}
    TSWRecipeList[TSWPlayerName][professionId]["name"] = professionName
    TSWRecipeList[TSWPlayerName][professionId]["categorys"] = {}
    ArrayEnchantTypes = {
        "Neck",
        "Bracer",
        "Cloak",
        "Ring",
        "Weapon",
        "Staff",
        "Boots",
        "Chest",
        "Gloves",
        "Shield",
        "Accords",
        "Wand",
        "Rod",
        "Other"
    }
    for i=1, #ArrayEnchantTypes do
        TSWRecipeList[TSWPlayerName][professionId]["categorys"][i] = {}
        TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["name"] = ArrayEnchantTypes[i]
        TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["description"] = ArrayEnchantTypes[i]
        
    end
    local itemCount = 1
    for c=1, GetNumCrafts() do
        local craftName, craftSubSpellName, craftType, numAvailable, isExpanded, trainingPointCost, requiredLevel = GetCraftInfo(c)
        skill = 375
        if craftType == "trivial" then skill = 50 end
        if craftType == "easy" then skill = 100 end
        if craftType == "medium" then skill =  200 end
        if craftType == "optimal" then skill = 300 end
        if craftType == "difficult" then skill = 375 end
        if (skill > TSWconfig["minRecipeLevel"] ) then
            for i=1, #ArrayEnchantTypes do
                -- Add to correct category
                
                if string.match(craftName, ArrayEnchantTypes[i]) or i == #ArrayEnchantTypes then
                    currentCategory = ArrayEnchantTypes[i]
                    local count
                    if not TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["items"] then
                        TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["items"] = {}
                        count = 1
                    else
                        count = #TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["items"] + 1
                    end
                    local itemLink = GetCraftItemLink(c)
                    local itemId = tonumber(string.match(itemLink, 'enchant:*(%d+)'))

                    TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["items"][count] = {}
                    TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["items"][count]["id"] = itemId
                    TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["items"][count]["link"] = itemLink
                    if TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["items"][count]["regents"] == nil then
                        TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["items"][count]["regents"] = {}
                    end
                    TSWDebug("Added: "..itemLink.." In: "..ArrayEnchantTypes[i].." Regents:"..GetCraftNumReagents(c))
                    for r=1, GetCraftNumReagents(c) do
                        local name, texturePath, numRequired, numHave = GetCraftReagentInfo(c, r);
                        local reagentLink = GetCraftReagentItemLink(c, r)
                        local reagentId = tonumber(string.match(reagentLink, 'item:*(%d+)'))

                        TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["items"][count]["regents"][r] = {}
                        TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["items"][count]["regents"][r]["id"] = reagentId
                        TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["items"][count]["regents"][r]["link"] = reagentLink
                        TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["items"][count]["regents"][r]["count"] = numRequired
                    end
                    break
                end
            end
        end
    end
end

function GenerateTailoringArray(professionName)
    local name, type, headerCount, itemCount, professionId, foundCloth, ArrayTailoringTypes, Keywords, professionNameShort;
    local professionId
    if professionName ~= "Tailoring" then
        return
    end
    if TSWRecipeList[TSWPlayerName] == nil then
        Pwc("New profile for "..TSWPlayerName)
        TSWRecipeList[TSWPlayerName] = {}
    end
    for i=1, 6 do
        if TSWRecipeList[TSWPlayerName][i] == nil then
            professionId = i
            Pwc(tostring(professionName).." added")
            break
        else
            if TSWRecipeList[TSWPlayerName][i]["name"] == professionName then
                professionId = i
                break
            end
        end
    end

    TSWRecipeList[TSWPlayerName][professionId] = {}
    TSWRecipeList[TSWPlayerName][professionId]["name"] = professionName
    TSWRecipeList[TSWPlayerName][professionId]["categorys"] = {}
    ArrayTailoringTypes = { 
        "Head",
        "Shoulders",
        "Shirt",
        "Robe",
        "Waist",
        "Legs",
        "Feet",
        "Wrist",
        "Hands",
        "Back",
        "Bag",
        "Thread",
        "Bolt",
        "Cloth",
        "Other"
    }

    Keywords = {
        ["Head"] = {
            "Hood",
        },
        ["Shoulders"] = {

        },
        ["Shirt"] = {

        },
        ["Robe"] = {
            "Chest",
            "Vest",
            "Tunic",
            "Armor",
            "Dress"
        },
        ["Waist"] = {
            "Belt",
        },
        ["Legs"] = {
            "Pantaloons",
            "Pants",
            "Leggings",
            "Kilt"
        },
        ["Feet"] = {
            "Boots",
        },
        ["Wrist"] = {
            "Bracers",
        },
        ["Hands"] = {
            "Gloves",
        },
        ["Back"] = {
            "Cloak",
            "Cape",
        },
        ["Bag"] = {
            "Pack",
            "bag"
        },
        ["Thread"] = {
            "Spellthread",
        },
        ["Bolt"] = {

        },
        ["Cloth"] = {
            "cloth",
        },
        ["Other"] = {

        },
    }
    for i=1, #ArrayTailoringTypes do
        TSWRecipeList[TSWPlayerName][professionId]["categorys"][i] = {}
        TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["name"] = ArrayTailoringTypes[i]
        TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["description"] = ArrayTailoringTypes[i]
    end
    local itemCount = 1
    for c=1, GetNumTradeSkills() do
        local skillName, skillType, numAvailable, isExpanded, altVerb, numSkillUps = GetTradeSkillInfo(c);
        if skillType ~= "header" then
            for i=1, #ArrayTailoringTypes do
                -- Add to correct category  
                local keyword = false
                
                if string.match(skillName, ArrayTailoringTypes[i]) then
                    keyword = true
                end
                if not keyword then
                    for k=1, #Keywords[ArrayTailoringTypes[i]] do
                        if string.match(skillName, Keywords[ArrayTailoringTypes[i]][k]) then
                            keyword = true
                            break
                        end
                    end
                end
                if keyword or i == #ArrayTailoringTypes then
                    currentCategory = ArrayTailoringTypes[i]
                    local count
                    if not TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["items"] then
                        TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["items"] = {}
                        count = 1
                    else
                        count = #TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["items"] + 1
                    end
                    local itemLink = GetTradeSkillItemLink(c)
                    local itemId = tonumber(string.match(itemLink, 'item:*(%d+)'))
                    TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["items"][count] = {}
                    TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["items"][count]["id"] = itemId
                    TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["items"][count]["link"] = itemLink
                    if TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["items"][count]["regents"] == nil then
                        TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["items"][count]["regents"] = {}
                    end
                    local numReagents = GetTradeSkillNumReagents(c)
                    TSWDebug("Added: "..itemLink.." In: "..ArrayTailoringTypes[i].." Regents:"..numReagents)
                    for r=1, numReagents do
                        local name, texturePath, numRequired, numHave = GetTradeSkillReagentInfo(c, r);
                        local reagentLink = GetTradeSkillReagentItemLink(c,r)
                        local reagentId = tonumber(string.match(reagentLink, 'item:*(%d+)'))

                        TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["items"][count]["regents"][r] = {}
                        TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["items"][count]["regents"][r]["id"] = reagentId
                        TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["items"][count]["regents"][r]["link"] = reagentLink
                        TSWRecipeList[TSWPlayerName][professionId]["categorys"][i]["items"][count]["regents"][r]["count"] = numRequired
                    end
                    break
                end
            end
        end
    end
end

function GenerateArray(professionName)
    local name, type, header, headerCount, itemCount, professionId, foundCloth, professionNameShort;
    headerCount = 0
    itemCount = 1
    foundCloth = false
    foundJewel = false
    
    if TSWRecipeList[TSWPlayerName] == nil then
        Pwc("New profile for "..TSWPlayerName)
        TSWRecipeList[TSWPlayerName] = {}
    end

    if not professionName or professionName == nil or professionName == "" or professionName == "Enchanting" then
        return
    end
    professionNameShort = string.sub(professionName, 1, 4)
    professionNameLetter = string.sub(professionName, 1, 1)
    for i=1,GetNumTradeSkills() do

        skillName, skillType, numAvailable, isExpanded, altVerb, numSkillUps = GetTradeSkillInfo(i);

        if(skillType == "header")then
            headerCount = headerCount + 1
            header = string.gsub(skillName, "[^%S]+", "")
            header = string.lower(header)
            header = header:gsub("^%l", string.upper)
            if header == "Cloth" and not foundCloth then
                header = "Clothwear"
                foundCloth = true
            end
            if header == "Jewelcrafting" and not foundJewel then
                header = "Jewels"
                foundJewel = true
            end
            if header == "Miscellaneous" then
                header = professionNameShort.."misc"
            end
            if header == "Other" then
                header = professionNameShort.."other"
            end
            if(headerCount == 1)then
                professionName = string.gsub(professionName, "[^%S]+", "")
                professionName = string.lower(professionName)
                professionName = professionName:gsub("^%l", string.upper)
                for i=1, 6 do
                    professionId = i
                    if TSWRecipeList[TSWPlayerName][professionId] == nil then
                        Pwc(professionName.." added")
                        TSWRecipeList[TSWPlayerName][professionId] = {}
                        --print("New profession: "..professionName.." Id:"..professionId)
                        TSWRecipeList[TSWPlayerName][professionId]["name"] = professionName
                        TSWRecipeList[TSWPlayerName][professionId]["categorys"] = {}
                        break
                    else
                        if TSWRecipeList[TSWPlayerName][professionId]["name"] == professionName then
                            --print("Profession: "..professionName.." Id:"..professionId)
                            break
                        end
                    end
                end
            end
            --print(professionId)
            TSWRecipeList[TSWPlayerName][professionId]["categorys"][headerCount] = {}
            local slotNames = {GetTradeSkillInvSlots()};
            TSWRecipeList[TSWPlayerName][professionId]["categorys"][headerCount]["name"] = header
            TSWRecipeList[TSWPlayerName][professionId]["categorys"][headerCount]["description"] = header
            TSWRecipeList[TSWPlayerName][professionId]["categorys"][headerCount]["items"] = {}
            itemCount = 1
        end
        skill = 375
        if skillType == "trivial" then skill = 10 end
        if skillType == "easy" then skill = 100 end
        if skillType == "medium" then skill =  200 end
        if skillType == "optimal" then skill = 300 end
        if skillType == "difficult" then skill = 375 end
       if (skillType ~= "header" and skill > TSWconfig["minRecipeLevel"] ) then
            
                
                --print(skill.." "..skillType)
            
            local itemLink = GetTradeSkillItemLink(i)
            local itemId = tonumber(string.match(itemLink, 'item:*(%d+)'))
            TSWRecipeList[TSWPlayerName][professionId]["categorys"][headerCount]["items"][itemCount] = {}
            TSWRecipeList[TSWPlayerName][professionId]["categorys"][headerCount]["items"][itemCount]["id"] = itemId
            TSWRecipeList[TSWPlayerName][professionId]["categorys"][headerCount]["items"][itemCount]["link"] = itemLink
            TSWRecipeList[TSWPlayerName][professionId]["categorys"][headerCount]["items"][itemCount]["show"] = true
            
            --print(skillName.." "..itemLink.." "..tostring(skillId))
            local numReagents = GetTradeSkillNumReagents(i)
            TSWRecipeList[TSWPlayerName][professionId]["categorys"][headerCount]["items"][itemCount]["regents"] = {}

            for r=1, numReagents do
                reagentName, reagentTexture, reagentCount, playerReagentCount = GetTradeSkillReagentInfo(i, r);
                reagentLink = GetTradeSkillReagentItemLink(i,r)
                reagentId = tonumber(string.match(reagentLink, 'item:*(%d+)'))
                TSWRecipeList[TSWPlayerName][professionId]["categorys"][headerCount]["items"][itemCount]["regents"][r] = {}
                TSWRecipeList[TSWPlayerName][professionId]["categorys"][headerCount]["items"][itemCount]["regents"][r]["id"] = reagentId
                TSWRecipeList[TSWPlayerName][professionId]["categorys"][headerCount]["items"][itemCount]["regents"][r]["link"] = reagentLink
                TSWRecipeList[TSWPlayerName][professionId]["categorys"][headerCount]["items"][itemCount]["regents"][r]["count"] = reagentCount
                --print(reagentLink.." x "..reagentCount.." "..reagentId)
            end
            itemCount = itemCount + 1
        end
    end
    --print("Number of professions: "..#TSWRecipeList)
end

function SendResponce(arg, array, to)
    if(#array > 0) then
        if(#arg == 1) then
            for i=1,#array do
                numerate = ""
                price = ""
                name = ""
                isPrefix = false
                prefixes = Prefixes()
                for i=1, #prefixes do
                    if arg[1] == prefixes[i]["name"] then
                        isPrefix = true
                        break
                    end
                end 
                if (isPrefix) then
                    name = array[i]
                else
                    numerate = i..": "
                    price = " - "..FormatPrice(GetPrice(array[i]["id"]))
                    name = array[i]["link"]
                    if string.match(name, "Enchant") then
                        price = ""
                    end
                    if string.match(name, "Rod") then
                        price = ""
                    end
                end 
                Whisper(numerate..name..price, to) 
            end
            return
        end

        if(#arg == 2 or #arg == 3) then
            arg2 = tonumber(arg[2])
            if(arg[3])then
                arg3 = tonumber(arg[3])
                arg3text = arg3.." x "    
            else
                arg3 = 1
                arg3text = ""
            end 
            
            Whisper(arg3text..""..array[arg2]["link"].." ingredients:", to)
            craftingCost = 0
            regents = array[arg2]["regents"]
            for i=1,#regents do
                Whisper((regents[i]["count"] * arg3).." x "..regents[i]["link"].." - "..FormatPrice(GetPrice(regents[i]["id"])), to) 
                craftingCost = craftingCost + ((GetPrice(regents[i]["id"]) * regents[i]["count"]))
            end
            craftingCost = FormatPrice(craftingCost * arg3)
            if GetPrice(array[arg2]["id"]) == nil then
                ahprice = FormatPrice(GetPrice(array[arg2]["id"]))
            else
                ahprice = FormatPrice(GetPrice(array[arg2]["id"]) * arg3)
            end
            local ahtext = " - AH price: "..ahprice
            if string.match(array[arg2]["link"], "Enchant") then
                ahtext = ""
            end
            if string.match(array[arg2]["link"], "Rod") then
                ahtext = ""
            end
            Whisper("Crafting cost: "..craftingCost..ahtext, to) 
            return
        end
    end   
end